Index: /palm/trunk/SOURCE/data_output_2d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_2d.f90	(revision 3273)
+++ /palm/trunk/SOURCE/data_output_2d.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -237,13 +240,16 @@
                precipitation_amount, prr, q, qc, ql, ql_c, ql_v, qr,           &
                rho_ocean, s, sa, tend, u, v, vpt, w, zu, zw,                   &
-               waterflux_output_conversion
-        
+               waterflux_output_conversion, hyrho, d_exner
+
     USE averaging
-        
-    USE cloud_parameters,                                                      &
-        ONLY:  cp, hyrho, l_d_cp, l_v, pt_d_t
-               
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  c_p, lv_d_cp, l_v
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model, bcm_data_output_2d
+
     USE control_parameters,                                                    &
-        ONLY:  cloud_physics, data_output_2d_on_each_pe, data_output_xy,       &
+        ONLY:  data_output_2d_on_each_pe, data_output_xy,                      &
                data_output_xz, data_output_yz, do2d,                           &
                do2d_xy_last_time, do2d_xy_time_count,                          &
@@ -254,20 +260,20 @@
                psolver, section, simulated_time,                               &
                time_since_reference_point, uv_exposure
-        
+
     USE cpulog,                                                                &
         ONLY:  cpu_log, log_point 
-        
+
     USE gust_mod,                                                              &
         ONLY:  gust_data_output_2d, gust_module_enabled
-        
+
     USE indices,                                                               &
         ONLY:  nbgp, nx, nxl, nxlg, nxr, nxrg, ny, nyn, nyng, nys, nysg,       &
                nzb, nzt, wall_flags_0
-               
+
     USE kinds
-    
+
     USE land_surface_model_mod,                                                &
         ONLY:  lsm_data_output_2d, zs
-    
+
 #if defined( __netcdf )
     USE NETCDF
@@ -579,28 +585,4 @@
                 level_z(nzb+1) = zu(nzb+1)
 
-             CASE ( 'nc_xy', 'nc_xz', 'nc_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => nc
-                ELSE
-                   IF ( .NOT. ALLOCATED( nc_av ) ) THEN
-                      ALLOCATE( nc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      nc_av = REAL( fill_value, KIND = wp )
-                   ENDIF
-                   to_be_resorted => nc_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zu
-
-             CASE ( 'nr_xy', 'nr_xz', 'nr_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => nr
-                ELSE
-                   IF ( .NOT. ALLOCATED( nr_av ) ) THEN
-                      ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      nr_av = REAL( fill_value, KIND = wp )
-                   ENDIF
-                   to_be_resorted => nr_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zu
-
              CASE ( 'ghf*_xy' )        ! 2d-array
                 IF ( av == 0 )  THEN
@@ -756,46 +738,7 @@
                 ENDIF
 
-             CASE ( 'pra*_xy' )        ! 2d-array / integral quantity => no av
-!                CALL exchange_horiz_2d( precipitation_amount )
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                      local_pf(i,j,nzb+1) =  precipitation_amount(j,i)
-                   ENDDO
-                ENDDO
-                precipitation_amount = 0.0_wp   ! reset for next integ. interval
-                resorted = .TRUE.
-                two_d = .TRUE.
-                level_z(nzb+1) = zu(nzb+1)
-
-             CASE ( 'prr_xy', 'prr_xz', 'prr_yz' )
-                IF ( av == 0 )  THEN
-!                   CALL exchange_horiz( prr, nbgp )
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         DO  k = nzb, nzt+1
-                            local_pf(i,j,k) = prr(k,j,i) * hyrho(nzb+1)
-                         ENDDO
-                      ENDDO
-                   ENDDO
-                ELSE
-                   IF ( .NOT. ALLOCATED( prr_av ) ) THEN
-                      ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      prr_av = REAL( fill_value, KIND = wp )
-                   ENDIF
-!                   CALL exchange_horiz( prr_av, nbgp )
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         DO  k = nzb, nzt+1
-                            local_pf(i,j,k) = prr_av(k,j,i) * hyrho(nzb+1)
-                         ENDDO
-                      ENDDO
-                   ENDDO
-                ENDIF
-                resorted = .TRUE.
-                IF ( mode == 'xy' )  level_z = zu
-
              CASE ( 'pt_xy', 'pt_xz', 'pt_yz' )
                 IF ( av == 0 )  THEN
-                   IF ( .NOT. cloud_physics ) THEN
+                   IF ( .NOT. bulk_cloud_model ) THEN
                       to_be_resorted => pt
                    ELSE
@@ -803,6 +746,6 @@
                       DO  j = nys, nyn
                             DO  k = nzb, nzt+1
-                               local_pf(i,j,k) = pt(k,j,i) + l_d_cp *          &
-                                                             pt_d_t(k) *       &
+                               local_pf(i,j,k) = pt(k,j,i) + lv_d_cp *         &
+                                                             d_exner(k) *      &
                                                              ql(k,j,i)
                             ENDDO
@@ -829,16 +772,4 @@
                    ENDIF
                    to_be_resorted => q_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zu
-
-             CASE ( 'qc_xy', 'qc_xz', 'qc_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => qc
-                ELSE
-                   IF ( .NOT. ALLOCATED( qc_av ) ) THEN
-                      ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      qc_av = REAL( fill_value, KIND = wp )
-                   ENDIF
-                   to_be_resorted => qc_av
                 ENDIF
                 IF ( mode == 'xy' )  level_z = zu
@@ -921,16 +852,4 @@
                 IF ( mode == 'xy' )  level_z = zu
 
-             CASE ( 'qr_xy', 'qr_xz', 'qr_yz' )
-                IF ( av == 0 )  THEN
-                   to_be_resorted => qr
-                ELSE
-                   IF ( .NOT. ALLOCATED( qr_av ) ) THEN
-                      ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                      qr_av = REAL( fill_value, KIND = wp )
-                   ENDIF
-                   to_be_resorted => qr_av
-                ENDIF
-                IF ( mode == 'xy' )  level_z = zu
-
              CASE ( 'qsws*_xy' )        ! 2d-array
                 IF ( av == 0 ) THEN
@@ -1071,5 +990,5 @@
                       j = surf_lsm_h%j(m)
                       k = surf_lsm_h%k(m)
-                      local_pf(i,j,nzb+1) = surf_lsm_h%shf(m) * cp
+                      local_pf(i,j,nzb+1) = surf_lsm_h%shf(m) * c_p
                    ENDDO
                    DO  m = 1, surf_usm_h%ns
@@ -1077,5 +996,5 @@
                       j = surf_usm_h%j(m)
                       k = surf_usm_h%k(m)
-                      local_pf(i,j,nzb+1) = surf_usm_h%shf(m) * cp
+                      local_pf(i,j,nzb+1) = surf_usm_h%shf(m) * c_p
                    ENDDO
                 ELSE
@@ -1387,15 +1306,22 @@
 
 !
-!--             Land surface model quantity
-                IF ( land_surface )  THEN
-                   CALL lsm_data_output_2d( av, do2d(av,if), found, grid, mode,&
-                                            local_pf, two_d, nzb_do, nzt_do )
-                ENDIF
-
-!
 !--             Turbulence closure variables
                 IF ( .NOT. found )  THEN
                    CALL tcm_data_output_2d( av, do2d(av,if), found, grid, mode,&
                                              local_pf, nzb_do, nzt_do )
+                ENDIF
+
+!
+!--             Microphysics module quantities
+                IF ( .NOT. found  .AND.  bulk_cloud_model )  THEN
+                   CALL bcm_data_output_2d( av, do2d(av,if), found, grid, mode,&
+                                            local_pf, two_d, nzb_do, nzt_do )
+                ENDIF
+
+!
+!--             Land surface model quantity
+                IF ( .NOT. found  .AND.  land_surface )  THEN
+                   CALL lsm_data_output_2d( av, do2d(av,if), found, grid, mode,&
+                                            local_pf, two_d, nzb_do, nzt_do )
                 ENDIF
 
@@ -1417,5 +1343,5 @@
 !
 !--             UV exposure model quantity
-                IF ( uv_exposure )  THEN
+                IF ( .NOT. found  .AND.  uv_exposure )  THEN
                    CALL uvem_data_output_2d( av, do2d(av,if), found, grid,     &
                                              local_pf, two_d, nzb_do, nzt_do )
Index: /palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_3d.f90	(revision 3273)
+++ /palm/trunk/SOURCE/data_output_3d.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables and format statements removed
 ! 
@@ -206,21 +209,24 @@
     USE arrays_3d,                                                             &
         ONLY:  e, nc, nr, p, pt, prr, q, qc, ql, ql_c, ql_v, qr, rho_ocean, s, &
-               sa, tend, u, v, vpt, w
-        
+               sa, tend, u, v, vpt, w, d_exner
+
     USE averaging
-        
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  lv_d_cp
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model, bcm_data_output_3d
+
     USE chemistry_model_mod,                                                   &
         ONLY:  chem_data_output_3d
 
-    USE cloud_parameters,                                                      &
-        ONLY:  l_d_cp, pt_d_t
-        
     USE control_parameters,                                                    &
-        ONLY:  air_chemistry, cloud_physics, do3d, do3d_no, do3d_time_count,   &
+        ONLY:  air_chemistry, do3d, do3d_no, do3d_time_count,                  &
                io_blocks, io_group, land_surface, message_string,              &
                ntdim_3d, nz_do3d,  plant_canopy,                               &
                psolver, simulated_time, time_since_reference_point,            &
                urban_surface, varnamelength
-        
+
     USE cpulog,                                                                &
         ONLY:  log_point, cpu_log
@@ -228,11 +234,11 @@
     USE gust_mod,                                                              &
         ONLY: gust_data_output_3d, gust_module_enabled
-        
+
     USE indices,                                                               &
         ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt,     &
                wall_flags_0
-        
+
     USE kinds
-    
+
     USE land_surface_model_mod,                                                &
         ONLY: lsm_data_output_3d, nzb_soil, nzt_soil
@@ -399,26 +405,4 @@
                 ENDIF
                 to_be_resorted => lpt_av
-             ENDIF
-
-          CASE ( 'nc' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => nc
-             ELSE
-                IF ( .NOT. ALLOCATED( nc_av ) ) THEN
-                   ALLOCATE( nc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   nc_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                to_be_resorted => nc_av
-             ENDIF
-
-          CASE ( 'nr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => nr
-             ELSE
-                IF ( .NOT. ALLOCATED( nr_av ) ) THEN
-                   ALLOCATE( nr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   nr_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                to_be_resorted => nr_av
              ENDIF
 
@@ -506,31 +490,7 @@
              ENDIF
 
-          CASE ( 'prr' )
-             IF ( av == 0 )  THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb_do, nzt_do
-                         local_pf(i,j,k) = prr(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ELSE
-                IF ( .NOT. ALLOCATED( prr_av ) ) THEN
-                   ALLOCATE( prr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   prr_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb_do, nzt_do
-                         local_pf(i,j,k) = prr_av(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-             ENDIF
-             resorted = .TRUE.
-
           CASE ( 'pt' )
              IF ( av == 0 )  THEN
-                IF ( .NOT. cloud_physics ) THEN
+                IF ( .NOT. bulk_cloud_model ) THEN
                    to_be_resorted => pt
                 ELSE
@@ -538,6 +498,6 @@
                       DO  j = nys, nyn
                          DO  k = nzb_do, nzt_do
-                            local_pf(i,j,k) = pt(k,j,i) + l_d_cp *             &
-                                                          pt_d_t(k) *          &
+                            local_pf(i,j,k) = pt(k,j,i) + lv_d_cp *            &
+                                                          d_exner(k) *         &
                                                           ql(k,j,i)
                          ENDDO
@@ -563,15 +523,4 @@
                 ENDIF
                 to_be_resorted => q_av
-             ENDIF
-
-          CASE ( 'qc' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => qc
-             ELSE
-                IF ( .NOT. ALLOCATED( qc_av ) ) THEN
-                   ALLOCATE( qc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   qc_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                to_be_resorted => qc_av
              ENDIF
 
@@ -647,15 +596,4 @@
              ENDIF
 
-          CASE ( 'qr' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => qr
-             ELSE
-                IF ( .NOT. ALLOCATED( qr_av ) ) THEN
-                   ALLOCATE( qr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   qr_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                to_be_resorted => qr_av
-             ENDIF
-
           CASE ( 'qv' )
              IF ( av == 0 )  THEN
@@ -758,12 +696,26 @@
 !--       Block of urban surface model outputs   
           CASE ( 'usm_output' )
-             CALL usm_data_output_3d( av, do3d(av,if), found, local_pf,     &
+             CALL usm_data_output_3d( av, do3d(av,if), found, local_pf,        &
                                          nzb_do, nzt_do )
 
           CASE DEFAULT
 
+             IF ( .NOT. found )  THEN
+                CALL tcm_data_output_3d( av, do3d(av,if), found, local_pf,     &
+                                         nzb_do, nzt_do )
+                resorted = .TRUE.
+             ENDIF
+
+!
+!--          Microphysic module quantities
+             IF ( .NOT. found  .AND.  bulk_cloud_model )  THEN
+                CALL bcm_data_output_3d( av, do3d(av,if), found, local_pf,     &
+                                         nzb_do, nzt_do )
+                resorted = .TRUE.
+             ENDIF
+
 !
 !--          Land surface quantity
-             IF ( land_surface )  THEN
+             IF ( .NOT. found  .AND.  land_surface )  THEN
 !
 !--             For soil model quantities, it is required to re-allocate local_pf
@@ -788,10 +740,4 @@
                 ENDIF
 
-             ENDIF
-
-             IF ( .NOT. found )  THEN
-                CALL tcm_data_output_3d( av, do3d(av,if), found, local_pf,     &
-                                         nzb_do, nzt_do )
-                resorted = .TRUE.
              ENDIF
 
Index: /palm/trunk/SOURCE/data_output_dvrp.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_dvrp.f90	(revision 3273)
+++ /palm/trunk/SOURCE/data_output_dvrp.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3045 2018-05-28 07:55:41Z Giersch
 ! Code adjusted according to PALM coding standards
 ! 
@@ -131,14 +134,11 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  p, pt, q, ql, s, ts, u, us, v, w, zu
-        
-    USE cloud_parameters,                                                      &
-        ONLY:  l_d_cp, pt_d_t
-        
-    USE constants,                                                             &
-        ONLY:  pi
-        
+        ONLY:  p, pt, q, ql, s, ts, u, us, v, w, zu, d_exner
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  pi, lv_d_cp
+
     USE control_parameters,                                                    &
-        ONLY:  cloud_droplets, cloud_physics, do2d, do3d, humidity, ibc_uv_b,  &
+        ONLY:  cloud_droplets, do2d, do3d, humidity, ibc_uv_b,                 &
                message_string, nz_do3d, passive_scalar, simulated_time,        &
                threshold
@@ -160,4 +160,7 @@
         
     USE kinds
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model
 
     USE pegrid
@@ -335,5 +338,5 @@
 
                 CASE ( 'pt', 'pt_xy', 'pt_xz', 'pt_yz' )
-                   IF ( .NOT. cloud_physics ) THEN
+                   IF ( .NOT. bulk_cloud_model ) THEN
                       DO  i = nxl_dvrp, nxr_dvrp+1
                          DO  j = nys_dvrp, nyn_dvrp+1
@@ -347,6 +350,6 @@
                          DO  j = nys_dvrp, nyn_dvrp+1
                             DO  k = nzb, nz_do3d
-                               local_pf(i,j,k) = pt(k,j,i) + l_d_cp *          &
-                                                 pt_d_t(k) * ql(k,j,i)
+                               local_pf(i,j,k) = pt(k,j,i) + lv_d_cp *         &
+                                                 d_exner(k) * ql(k,j,i)
                             ENDDO
                          ENDDO
@@ -372,5 +375,5 @@
              
                 CASE ( 'ql', 'ql_xy', 'ql_xz', 'ql_yz' )
-                   IF ( cloud_physics  .OR.  cloud_droplets )  THEN
+                   IF ( bulk_cloud_model  .OR.  cloud_droplets )  THEN
                       DO  i = nxl_dvrp, nxr_dvrp+1
                          DO  j = nys_dvrp, nyn_dvrp+1
@@ -381,5 +384,5 @@
                       ENDDO
                    ELSE                     
-                      message_string = 'if cloud_physics = .FALSE. and ' //    & 
+                      message_string = 'if bulk_cloud_model = .FALSE. and ' // &
                                   'cloud_droplets = .FALSE. '
                                   'output of ' // TRIM( output_variable) //    &
Index: /palm/trunk/SOURCE/data_output_mask.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_mask.f90	(revision 3273)
+++ /palm/trunk/SOURCE/data_output_mask.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variable removed
 ! 
@@ -129,5 +132,5 @@
     USE arrays_3d,                                                             &
         ONLY:  e, nc, nr, p, pt, q, qc, ql, ql_c, ql_v, qr, rho_ocean, s, sa,  &
-               tend, u, v, vpt, w
+               tend, u, v, vpt, w, d_exner
     
     USE averaging,                                                             &
@@ -135,10 +138,10 @@
                qc_av, ql_av, ql_c_av, ql_v_av, ql_vp_av, qv_av, qr_av,         &
                rho_ocean_av, s_av, sa_av, u_av, v_av, vpt_av, w_av 
-    
-    USE cloud_parameters,                                                      &
-        ONLY:  l_d_cp, pt_d_t
+
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:  lv_d_cp
     
     USE control_parameters,                                                    &
-        ONLY:  cloud_physics, domask, domask_no, domask_time_count, mask_i,    &
+        ONLY:  domask, domask_no, domask_time_count, mask_i,                   &
                mask_j, mask_k, mask_size, mask_size_l, mask_start_l,           &
                max_masks, message_string, mid, nz_do3d, simulated_time
@@ -150,4 +153,7 @@
         
     USE kinds
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY:  bulk_cloud_model
     
     USE NETCDF
@@ -354,5 +360,5 @@
           CASE ( 'pt' )
              IF ( av == 0 )  THEN
-                IF ( .NOT. cloud_physics ) THEN
+                IF ( .NOT. bulk_cloud_model ) THEN
                    to_be_resorted => pt
                 ELSE
@@ -362,5 +368,5 @@
                             local_pf(i,j,k) =  &
                                  pt(mask_k(mid,k),mask_j(mid,j),mask_i(mid,i)) &
-                                 + l_d_cp * pt_d_t(mask_k(mid,k)) * &
+                                 + lv_d_cp * d_exner(mask_k(mid,k)) *          &
                                    ql(mask_k(mid,k),mask_j(mid,j),mask_i(mid,i))
                          ENDDO
Index: /palm/trunk/SOURCE/data_output_spectra.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_spectra.f90	(revision 3273)
+++ /palm/trunk/SOURCE/data_output_spectra.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -238,5 +241,5 @@
 #if defined( __netcdf )
 
-    USE constants,                                                             &
+    USE basic_constants_and_equations_mod,                                     &
         ONLY:  pi
 
Index: /palm/trunk/SOURCE/flow_statistics.f90
===================================================================
--- /palm/trunk/SOURCE/flow_statistics.f90	(revision 3273)
+++ /palm/trunk/SOURCE/flow_statistics.f90	(revision 3274)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Modularization of all bulk cloud physics code components
+! 
+! 3241 2018-09-12 15:02:00Z raasch
 ! unused variables removed
 ! 
@@ -283,16 +286,16 @@
                momentumflux_output_conversion, nc, nr, p, prho, prr, pt, q,    &
                qc, ql, qr, rho_air, rho_air_zw, rho_ocean, s,                  &
-               sa, u, ug, v, vg, vpt, w, w_subs, waterflux_output_conversion, zw
+               sa, u, ug, v, vg, vpt, w, w_subs, waterflux_output_conversion,  &
+               zw, d_exner
         
-    USE cloud_parameters,                                                      &
-        ONLY:   l_d_cp, pt_d_t
+    USE basic_constants_and_equations_mod,                                     &
+        ONLY:   g, lv_d_cp
         
     USE control_parameters,                                                    &
-        ONLY:   average_count_pr, cloud_droplets, cloud_physics, do_sum,       &
-                dt_3d, g, humidity, initializing_actions, land_surface,        &
+        ONLY:   average_count_pr, cloud_droplets, do_sum,                      &
+                dt_3d, humidity, initializing_actions, land_surface,           &
                 large_scale_forcing, large_scale_subsidence, max_pr_user,      &
-                message_string, neutral, microphysics_morrison,                &
-                microphysics_seifert, ocean, passive_scalar, simulated_time,   &
-                simulated_time_at_begin, use_subsidence_tendencies,            & 
+                message_string, neutral, ocean, passive_scalar, simulated_time,&
+                simulated_time_at_begin, use_subsidence_tendencies,            &
                 use_surface_fluxes, use_top_fluxes, ws_scheme_mom,             &
                 ws_scheme_sca
@@ -313,4 +316,7 @@
         
     USE kinds
+
+    USE bulk_cloud_model_mod,                                                  &
+        ONLY: bulk_cloud_model, microphysics_morrison, microphysics_seifert
     
     USE land_surface_model_mod,                                                &
@@ -515,5 +521,5 @@
              ENDDO
           ENDDO
-          IF ( cloud_physics )  THEN
+          IF ( bulk_cloud_model )  THEN
              !$OMP DO
              DO  i = nxl, nxr
@@ -525,5 +531,5 @@
                                                                * flag
                       sums_l(k,43,tn) = sums_l(k,43,tn) + (                    &
-                                      pt(k,j,i) + l_d_cp*pt_d_t(k) * ql(k,j,i) &
+                                      pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i) &
                                                           ) * rmask(j,i,sr)    &
                                                             * flag
@@ -563,5 +569,5 @@
                 sums_l(:,41,0) = sums_l(:,41,0) + sums_l(:,41,i)
                 sums_l(:,44,0) = sums_l(:,44,0) + sums_l(:,44,i)
-                IF ( cloud_physics )  THEN
+                IF ( bulk_cloud_model )  THEN
                    sums_l(:,42,0) = sums_l(:,42,0) + sums_l(:,42,i)
                    sums_l(:,43,0) = sums_l(:,43,0) + sums_l(:,43,i)
@@ -598,5 +604,5 @@
           CALL MPI_ALLREDUCE( sums_l(nzb,41,0), sums(nzb,41), nzt+2-nzb,       &
                               MPI_REAL, MPI_SUM, comm2d, ierr )
-          IF ( cloud_physics ) THEN
+          IF ( bulk_cloud_model ) THEN
              IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
              CALL MPI_ALLREDUCE( sums_l(nzb,42,0), sums(nzb,42), nzt+2-nzb,    &
@@ -621,5 +627,5 @@
           sums(:,44) = sums_l(:,44,0)
           sums(:,41) = sums_l(:,41,0)
-          IF ( cloud_physics ) THEN
+          IF ( bulk_cloud_model ) THEN
              sums(:,42) = sums_l(:,42,0)
              sums(:,43) = sums_l(:,43,0)
@@ -654,5 +660,5 @@
           hom(:,1,44,sr) = sums(:,44)             ! vpt
           hom(:,1,41,sr) = sums(:,41)             ! qv (q)
-          IF ( cloud_physics ) THEN
+          IF ( bulk_cloud_model ) THEN
              sums(:,42) = sums(:,42) / ngp_2dh_s_inner(:,sr)
              sums(:,43) = sums(:,43) / ngp_2dh_s_inner(:,sr)
@@ -948,5 +954,5 @@
                                                * ddzu(k+1) * rmask(j,i,sr) * flag
 
-                   IF ( cloud_physics ) THEN
+                   IF ( bulk_cloud_model ) THEN
                       sums_l(k,51,tn) = sums_l(k,51,tn)                        &
                                          - 0.5_wp * ( kh(k,j,i) + kh(k+1,j,i) )&
@@ -1014,5 +1020,5 @@
                                           * heatflux_output_conversion(k+ki)
                             ENDIF
-                            IF ( cloud_physics )  THEN
+                            IF ( bulk_cloud_model )  THEN
 !
 !--                            Formula does not work if ql(k+ki) /= 0.0
@@ -1067,5 +1073,5 @@
                                           * heatflux_output_conversion(nzb)
                       ENDIF
-                      IF ( cloud_physics )  THEN
+                      IF ( bulk_cloud_model )  THEN
 !
 !--                      Formula does not work if ql(nzb) /= 0.0
@@ -1118,5 +1124,5 @@
                                           * heatflux_output_conversion(nzb)
                       ENDIF
-                      IF ( cloud_physics )  THEN
+                      IF ( bulk_cloud_model )  THEN
 !
 !--                      Formula does not work if ql(nzb) /= 0.0
@@ -1293,5 +1299,5 @@
                                            * heatflux_output_conversion(nzt)
                    ENDIF
-                   IF ( cloud_physics )  THEN
+                   IF ( bulk_cloud_model )  THEN
 !
 !--                   Formula does not work if ql(nzb) /= 0.0
@@ -1347,5 +1353,5 @@
 !--             content, rain drop concentration and rain water content
                 IF ( humidity )  THEN
-                   IF ( cloud_physics .OR. cloud_droplets )  THEN
+                   IF ( bulk_cloud_model .OR. cloud_droplets )  THEN
                       pts = 0.5_wp * ( vpt(k,j,i)   - hom(k,1,44,sr) +         &
                                     vpt(k+1,j,i) - hom(k+1,1,44,sr) )
